/*!
 * @file atmospheric_engine.h
 *  
 */

#ifndef _ATMOSPHERIC_ENGINE_H
#define _ATMOSPHERIC_ENGINE_H

#include "base_object.h"


class TiXmlElement;

class AtmosphericEngine : public BaseObject
{
  public:
    virtual ~AtmosphericEngine();

    /** @returns a Pointer to the only object of this Class */
    inline static AtmosphericEngine* getInstance() { if (!AtmosphericEngine::singletonRef) AtmosphericEngine::singletonRef = new AtmosphericEngine();  return AtmosphericEngine::singletonRef; };

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    //virtual bool activate() = 0;
    //virtual bool deactivate() = 0;

    virtual void draw() const;
    virtual void tick(float dt);

    inline bool isActivated() const { return this->bActivated; }

    void loadWeatherEffects(const TiXmlElement* root);
    void loadSunEffects(const TiXmlElement* root);

  private:

    AtmosphericEngine();

    static AtmosphericEngine*     singletonRef;       //!< Pointer to the only instance of this Class

  protected:
    bool              bActivated;
};


#endif /* _ATMOSPHERIC_ENGINE */
