/*!
 * @file sun_effects.h
 *  
 */

#ifndef _SUN_EFFECTS_H
#define _SUN_EFFECTS_H

#include "base_object.h"


class TiXmlElement;

class SunEffects : public BaseObject
{
  public:
    SunEffects(const TiXmlElement* root = NULL);
    virtual ~SunEffects();

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    virtual bool activate() = 0;
    virtual bool deactivate() = 0;

    virtual void draw() const;
    virtual void tick(float dt);

    inline bool isActivated() const { return this->bActivated; }

  protected:
    bool              bActivated;
};


#endif /* _SUN_EFFECTS */