/*!
 * @file weather_effects.h
 *  
 */

#ifndef _WEATHER_EFFECTS_H
#define _WEATHER_EFFECTS_H

#include "base_object.h"


class WeatherEffects : public BaseObject
{
  public:
    WeatherEffects(const TiXmlElement* root = NULL);
    virtual ~WeatherEffects();

    virtual void loadParams(const TiXmlElement* root);

    virtual bool init();

    virtual bool activate() = 0;
    virtual bool deactivate() = 0;

    virtual void draw() const;
    virtual void tick(float dt);

    inline bool isActivated() const { return this->bActivated; }


  protected:
    bool              bActivated;
};


#endif /* _WEATHER_EFFECTS */
